template_secsec_functional = """lemma sec{}_sec{}_functional: exists-trace
"
    Ex #i1 #i2 .
    InitWillDoSec{}()[+] @i1 & RespWillDoSec{}()[+] @i2 &
    (Ex idI1 idR1 capI1 capR1 pkI1 pkR1 dh1 ltk1 idI2 idR2 capI2 capR2 pkI2 pkR2 dh2 ltk2 #j1 #j2 .
        InitiatorFinishedSecPairing(idI1, capI1, idR1, capR1, pkI1, pkR1, dh1, ltk1) @j1 &
        ResponderFinishedSecPairing(idR2, capR2, idI2, capI2, pkR2, pkI2, dh2, ltk2) @j2
    )
"
"""

template_secsec_auth_init = """lemma sec{}_sec{}_auth_init:
"
    All #i1 #i2 .
    InitWillDoSec{}()[+] @i1 & RespWillDoSec{}()[+] @i2 ==>
        (All idI idR capI capR pkI pkR dh ltk #k1 .
            InitiatorFinishedSecPairing(idI, capI, idR, capR, pkI, pkR, dh, ltk) @k1 ==>
            (Ex ni nr ri rr ei er #k2 .
                RespDoneDHKeyCheck(idR, capR, idI, capI, pkR, pkI, dh, nr, ni, rr, ri, er, ei) @k2
            )
        )
"
"""

template_secsec_auth_resp = """lemma sec{}_sec{}_auth_resp:
"
    All #i1 #i2 .
        InitWillDoSec{}()[+] @i1 & RespWillDoSec{}()[+] @i2 ==>
        (All idI idR capI capR pkI pkR dh ltk #k1 .
            ResponderFinishedSecPairing(idR, capR, idI, capI, pkR, pkI, dh, ltk) @k1 ==>
            (Ex #k2 .
                InitiatorFinishedSecPairing(idI, capI, idR, capR, pkI, pkR, dh, ltk) @k2
            )
        )
"
"""

template_secsec_weaksecret_init = """lemma sec{}_sec{}_weaksecret_init:
"
    All #i1 #i2 .
        InitWillDoSec{}()[+] @i1 & RespWillDoSec{}()[+] @i2 ==>
        (All idI idR capI capR pkI pkR dh ltk #k1 .
            InitiatorFinishedSecPairing(idI, capI, idR, capR, pkI, pkR, dh, ltk) @k1 ==>
            not (Ex #k2 . K(ltk) @k2)
        )
"
"""

template_secsec_weaksecret_resp = """lemma sec{}_sec{}_weaksecret_resp:
"
    All #i1 #i2 .
        InitWillDoSec{}()[+] @i1 & RespWillDoSec{}()[+] @i2 ==>
        (All idI idR capI capR pkI pkR dh ltk #k1 .
            ResponderFinishedSecPairing(idR, capR, idI, capI, pkR, pkI, dh, ltk) @k1 ==>
            not (Ex #k2 . K(ltk) @k2)
        )
"
"""

template_secsec_double_impersonation = """lemma sec{}_sec{}_double_impersonation:
"
    All #i1 #i2 .
        InitWillDoSec{}()[+] @i1 & RespWillDoSec{}()[+] @i2 ==>
        (All idI1 idR1 capI1 capR1 pkI1 pkR1 dh1 ltk1 idI2 idR2 capI2 capR2 pkI2 pkR2 dh2 ltk2 #j1 #j2 .
            InitiatorFinishedSecPairing(idI1, capI1, idR1, capR1, pkI1, pkR1, dh1, ltk1) @j1 &
            ResponderFinishedSecPairing(idR2, capR2, idI2, capI2, pkR2, pkI2, dh2, ltk2) @j2 ==>
            not (Ex #k1 #k2 .
                K(ltk1) @k1 & K(ltk2) @k2
            )
        )
"
"""

template_legleg_functional = """lemma leg{}_leg{}_functional: exists-trace
"
    Ex #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 &
    (Ex idI1 idR1 capI1 capR1 tk1 ni1 nr1 stk1 idI2 idR2 capI2 capR2 tk2 ni2 nr2 stk2 #j1 #j2 .
        InitiatorFinishedLegPairing(idI1, capI1, idR1, capR1, tk1, ni1, nr1, stk1) @j1 &
        ResponderFinishedLegPairing(idR2, capR2, idI2, capI2, tk2, nr2, ni2, stk2) @j2
    )
"
"""

template_legleg_auth_init = """lemma leg{}_leg{}_auth_init:
"
    All #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 ==>
        (All idI idR capI capR tk ni nr stk #k1 .
            InitiatorFinishedLegPairing(idI, capI, idR, capR, tk, ni, nr, stk) @k1 ==>
            (Ex ci cr #k2 .
                RespSentRandom(idR, capR, idI, capI, tk, nr, ni, cr, ci) @k2
            )
        )
"
"""

template_legleg_auth_resp = """lemma leg{}_leg{}_auth_resp:
"
    All #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 ==>
        (All idI idR capI capR tk ni nr stk #k1 .
            ResponderFinishedLegPairing(idR, capR, idI, capI, tk, nr, ni, stk) @k1 ==>
            (Ex ci cr #k2 .
                InitSentRandom(idI, capI, idR, capR, tk, ni, ci, cr) @k2
            )
        )
"
"""

template_legleg_weaksecret_init = """lemma leg{}_leg{}_weaksecret_init:
"
    All #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 ==>
        (All idI idR capI capR tk ni nr stk #k1 .
            InitiatorFinishedLegPairing(idI, capI, idR, capR, tk, ni, nr, stk) @k1 ==>
            not (Ex #k2 . K(stk) @k2 )
        )
"
"""

template_legleg_weaksecret_resp = """lemma leg{}_leg{}_weaksecret_resp:
"
    All #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 ==>
        (All idI idR capI capR tk ni nr stk #k1 .
            ResponderFinishedLegPairing(idR, capR, idI, capI, tk, nr, ni, stk) @k1 ==>
            not (Ex #k2 . K(stk) @k2 )
        )
"
"""

template_legleg_double_impersonation = """lemma leg{}_leg{}_double_impersonation:
"
    All #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 ==>
    (All idI1 idR1 capI1 capR1 tk1 ni1 nr1 stk1 idI2 idR2 capI2 capR2 tk2 ni2 nr2 stk2 #j1 #j2 .
        InitiatorFinishedLegPairing(idI1, capI1, idR1, capR1, tk1, ni1, nr1, stk1) @j1 &
        ResponderFinishedLegPairing(idR2, capR2, idI2, capI2, tk2, nr2, ni2, stk2) @j2 ==>
        not (Ex #k1 #k2 .
            K(stk1) @k1 & K(stk2) @k2
        )
    )
"
"""

template_legsec_functional = """lemma leg{}_sec{}_functional: exists-trace
"
    Ex #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoSec{}()[+] @i2 &
    (Ex idI1 idR1 capI1 capR1 idI2 idR2 capI2 capR2 tk ni nr stk pkI pkR dh ltk #j1 #j2 .
        InitiatorFinishedLegPairing(idI1, capI1, idR1, capR1, tk, ni, nr, stk) @j1 &
        ResponderFinishedSecPairing(idR2, capR2, idI2, capI2, pkR, pkI, dh, ltk) @j2
    )
"
"""

template_legsec_auth_init = """lemma leg{}_sec{}_auth_init:
"
    All idI idR capI capR tk nli nlr stk #i1 #i2 #j .
    InitWillDoLeg{}()[+] @i1 & RespWillDoSec{}()[+] @i2 &
    InitiatorFinishedLegPairing(idI, capI, idR, capR, tk, nli, nlr, stk) @j ==>
        (Ex pkI pkR dh nsi nsr ri rr ei er #k .
            RespDoneDHKeyCheck(idR, capR, idI, capI, pkR, pkI, dh, nsr, nsi, rr, ri, er, ei) @k
        )
"
"""

template_legsec_auth_resp = """lemma leg{}_sec{}_auth_resp:
"
    All idI idR capI capR pkI pkR dh ltk #i1 #i2 #j .
    InitWillDoLeg{}()[+] @i1 & RespWillDoSec{}()[+] @i2 &
    ResponderFinishedSecPairing(idR, capR, idI, capI, pkI, pkR, dh, ltk) @j ==>
        (Ex tk ni ci cr #k .
            InitSentRandom(idI, capI, idR, capR, tk, ni, ci, cr) @k
        )
"
"""

template_legsec_weaksecret_init = """lemma leg{}_sec{}_weaksecret_init:
"
    All idI idR capI capR tk ni nr stk #i1 #i2 #j.
    InitWillDoLeg{}()[+] @i1 & RespWillDoSec{}()[+] @i2 &
    InitiatorFinishedLegPairing(idI, capI, idR, capR, tk, ni, nr, stk) @j ==>
        not (Ex #k . K(stk) @k )
"
"""

template_legsec_weaksecret_resp = """lemma leg{}_sec{}_weaksecret_resp:
"
    All idI idR capI capR pkI pkR dh ltk #i1 #i2 #j.
    InitWillDoLeg{}()[+] @i1 & RespWillDoSec{}()[+] @i2 &
    ResponderFinishedSecPairing(idR, capR, idI, capI, pkI, pkR, dh, ltk) @j ==>
        not (Ex #k . K(ltk) @k )
"
"""

template_legsec_double_impersonation = """lemma leg{}_sec{}_double_impersonation: 
"
    All #i1 #i2 .
    InitWillDoLeg{}()[+] @i1 & RespWillDoSec{}()[+] @i2 ==>
    (All idI1 idR1 capI1 capR1 idI2 idR2 capI2 capR2 tk ni nr stk pkI pkR dh ltk #j1 #j2 .
        InitiatorFinishedLegPairing(idI1, capI1, idR1, capR1, tk, ni, nr, stk) @j1 &
        ResponderFinishedSecPairing(idR2, capR2, idI2, capI2, pkR, pkI, dh, ltk) @j2 ==>
        not (Ex #k1 #k2 .
            K(stk) @k1 & K(ltk) @k2
        )
    )
"
"""

template_secleg_functional = """lemma sec{}_leg{}_functional: exists-trace
"
    Ex #i1 #i2 .
    InitWillDoSec{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 &
    (Ex idI1 idR1 capI1 capR1 idI2 idR2 capI2 capR2 tk ni nr stk pkI pkR dh ltk #j1 #j2 .
        InitiatorFinishedSecPairing(idI1, capI1, idR1, capR1, pkI, pkR, dh, ltk) @j1 &
        ResponderFinishedLegPairing(idR2, capR2, idI2, capI2, tk, nr, ni, stk) @j2
    )
"
"""

template_secleg_auth_init = """lemma sec{}_leg{}_auth_init:
"
    All idI idR capI capR pkI pkR dh ltk #i1 #i2 #j .
    InitWillDoSec{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 &
    InitiatorFinishedSecPairing(idI, capI, idR, capR, pkI, pkR, dh, ltk) @j ==>
        (Ex tk ni nr ci cr #k.
            RespSentRandom(idR, capR, idI, capI, tk, nr, ni, cr, ci) @k
        )
"
"""

template_secleg_auth_resp = """lemma sec{}_leg{}_auth_resp:
"
    All idI idR capI capR tk ni nr stk #i1 #i2 #j.
    InitWillDoSec{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 &
    ResponderFinishedLegPairing(idR, capR, idI, capI, tk, nr, ni, stk) @j ==>
        (Ex pkI pkR dh nsi nsr ri rr ei #k .
            InitDHKeyCheck(idI, capI, idR, capR, pkI, pkR, dh, nsi, nsr, ri, rr, ei) @k
        )
"
"""

template_secleg_weaksecret_init = """lemma sec{}_leg{}_weaksecret_init:
"
    All idI idR capI capR pkI pkR dh ltk #i1 #i2 #j .
    InitWillDoSec{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 &
    InitiatorFinishedSecPairing(idI, capI, idR, capR, pkI, pkR, dh, ltk) @j ==>
        not (Ex #k. K(ltk) @k )
"
"""

template_secleg_weaksecret_resp = """lemma sec{}_leg{}_weaksecret_resp:
"
    All idI idR capI capR tk ni nr stk #i1 #i2 #j .
    InitWillDoSec{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 &
    ResponderFinishedLegPairing(idR, capR, idI, capI, tk, nr, ni, stk) @j ==>
        not (Ex #k. K(stk) @k )
"
"""

template_secleg_double_impersonation = """lemma sec{}_leg{}_double_impersonation:
"
    All #i1 #i2 .
    InitWillDoSec{}()[+] @i1 & RespWillDoLeg{}()[+] @i2 ==>
    (All idI1 idR1 capI1 capR1 idI2 idR2 capI2 capR2 tk ni nr stk pkI pkR dh ltk #j1 #j2 .
        InitiatorFinishedSecPairing(idI1, capI1, idR1, capR1, pkI, pkR, dh, ltk) @j1 &
        ResponderFinishedLegPairing(idR2, capR2, idI2, capI2, tk, nr, ni, stk) @j2 ==>
        not (Ex #k1 #k2 .
            K(ltk) @k1 & K(stk) @k2
        )
    )
"
"""

def get_cli(im, rm, iio, rio, init_unpatched, resp_unpatched):
    cli = ["tamarin-prover", "ble.spthy"]
    # Legacy or Secure Pairing
    if im == "l":
        cli.append("-DInitLeg")
        if iio == "JW":
            cli.append("-DInitLegJW")
        if iio == "PEi":
            cli.append("-DInitLegPE")
            cli.append("-DInitLegPEi")
        if iio == "PEo":
            cli.append("-DInitLegPE")
            cli.append("-DInitLegPEo")
        if iio == "PEio":
            cli.append("-DInitLegPE")
            cli.append("-DInitLegPEio")
        if iio == "OOB":
            cli.append("-DInitLegOOB")
    elif im == "s":
        cli.append("-DInitSec")
        if iio == "JW":
            cli.append("-DInitSecJW")
        if iio == "PEi":
            cli.append("-DInitSecPE")
            cli.append("-DInitSecPEi")
        if iio == "PEo":
            cli.append("-DInitSecPE")
            cli.append("-DInitSecPEo")
        if iio == "PEio":
            cli.append("-DInitSecPE")
            cli.append("-DInitSecPEio")
        if iio == "NC":
            cli.append("-DInitSecNC")
        if iio == "OOBi":
            cli.append("-DInitSecOOB")
            cli.append("-DInitSecOOBi")
        if iio == "OOBo":
            cli.append("-DInitSecOOB")
            cli.append("-DInitSecOOBo")
        if iio == "OOBio":
            cli.append("-DInitSecOOB")
            cli.append("-DInitSecOOBio")

        if init_unpatched:
            cli.append("-DInitECDHUnpatched")

    if rm == "l":
        cli.append("-DRespLeg")
        if rio == "JW":
            cli.append("-DRespLegJW")
        if rio == "PEi":
            cli.append("-DRespLegPE")
            cli.append("-DRespLegPEi")
        if rio == "PEo":
            cli.append("-DRespLegPE")
            cli.append("-DRespLegPEo")
        if rio == "PEio":
            cli.append("-DRespLegPE")
            cli.append("-DRespLegPEio")
        if rio == "OOB":
            cli.append("-DRespLegOOB")
    elif rm == "s":
        cli.append("-DRespSec")
        if rio == "JW":
            cli.append("-DRespSecJW")
        if rio == "PEi":
            cli.append("-DRespSecPE")
            cli.append("-DRespSecPEi")
        if rio == "PEo":
            cli.append("-DRespSecPE")
            cli.append("-DRespSecPEo")
        if rio == "PEio":
            cli.append("-DRespSecPE")
            cli.append("-DRespSecPEio")
        if rio == "NC":
            cli.append("-DRespSecNC")
        if rio == "OOBi":
            cli.append("-DRespSecOOB")
            cli.append("-DRespSecOOBi")
        if rio == "OOBo":
            cli.append("-DRespSecOOB")
            cli.append("-DRespSecOOBo")
        if rio == "OOBio":
            cli.append("-DRespSecOOB")
            cli.append("-DRespSecOOBio")

        if resp_unpatched:
            cli.append("-DRespECDHUnpatched")

    if init_unpatched or resp_unpatched:
        cli.append("-DECDHUnpatched")

    method = "-D"
    if im == "l":
        method += "Leg"
    elif im == "s":
        method += "Sec"
    method += f"{iio}"
    if rm == "l":
        method += "Leg"
    elif rm == "s":
        method += "Sec"
    method += f"{rio}"
    cli.append(method)

    if iio == "PEi":
        if rio == "PEi":
            cli.append("-DInputInput")
        elif rio == "PEo":
            cli.append("-DInputOutput")
        elif rio == "PEio":
            cli.append("-DInputInout")
        elif rio == "NC":
            cli.append("-DInputOutput")
        else:
            cli.append("-DInputInput")
            cli.append("-DInputOutput")
            cli.append("-DInputInout")
    if iio == "PEo":
        if rio == "PEi":
            cli.append("-DOutputInput")
        elif rio == "PEo":
            cli.append("-DOutputOutput")
        elif rio == "PEio":
            cli.append("-DOutputInout")
        elif rio == "NC":
            cli.append("-DOutputOutput")
        else:
            cli.append("-DOutputInput")
            cli.append("-DOutputOutput")
            cli.append("-DOutputInout")
    if iio == "PEio":
        if rio == "PEi":
            cli.append("-DInoutInput")
        elif rio == "PEo":
            cli.append("-DInoutOutput")
        elif rio == "PEio":
            cli.append("-DInoutInout")
        elif rio == "NC":
            cli.append("-DInoutOutput")
        else:
            cli.append("-DInoutInput")
            cli.append("-DInoutOutput")
            cli.append("-DInoutInout")
    if iio == "NC":
        if rio == "PEi":
            cli.append("-DOutputInput")
        elif rio == "PEo":
            cli.append("-DOutputOutput")
        elif rio == "PEio":
            cli.append("-DOutputInout")
        elif rio == "NC":
            cli.append("-DOutputOutput")
        else:
            cli.append("-DOutputInput")
            cli.append("-DOutputOutput")
            cli.append("-DOutputInout")
    cli.append("--prove")
    return " ".join(cli)

legi = ["JW", "PEi", "PEo", "PEio", "OOB"]
legr = ["JW", "PEi", "PEo", "PEio", "OOB"]
seci = ["JW", "PEi", "PEo", "PEio", "NC", "OOBi", "OOBo", "OOBio"]
secr = ["JW", "PEi", "PEo", "PEio", "NC", "OOBi", "OOBo", "OOBio"]

all_flags = []

clis = []
for iio in legi:
    for rio in legr:
        hdr = "/* Lemmas about Leg{}-Leg{} exchange */".format(iio, rio)
        hdr1 = "/*" + "*" * (len(hdr)-4) + "*/"

        ftr = "/* End lemmas about Leg{}-Leg{} exchange */".format(iio, rio)
        ftr1 = "/*" + "*" * (len(ftr)-4) + "*/"
        print(hdr1)
        print(hdr)
        print(hdr1)
        print()
        print("#ifdef Leg{}Leg{}".format(iio, rio))
        print(template_legleg_functional.format(iio, rio, iio, rio))
        print(template_legleg_auth_init.format(iio, rio, iio, rio))
        print(template_legleg_auth_resp.format(iio, rio, iio, rio))
        print(template_legleg_weaksecret_init.format(iio, rio, iio, rio))
        print(template_legleg_weaksecret_resp.format(iio, rio, iio, rio))
        print(template_legleg_double_impersonation.format(iio, rio, iio, rio))
        print("#endif")
        print()
        print(ftr1)
        print(ftr)
        print(ftr1)
        print()

        curr_cli = get_cli("l", "l", iio, rio, False, False)
        clis.append(curr_cli)

        all_flags.append(("Leg{}Leg{}".format(iio, rio), curr_cli))

for iio in seci:
    for rio in secr:
        hdr = "/* Lemmas about Sec{}-Sec{} exchange */".format(iio, rio)
        hdr1 = "/*" + "*" * (len(hdr)-4) + "*/"

        ftr = "/* End lemmas about Sec{}-Sec{} exchange */".format(iio, rio)
        ftr1 = "/*" + "*" * (len(ftr)-4) + "*/"
        print(hdr1)
        print(hdr)
        print(hdr1)
        print()
        print("#ifdef Sec{}Sec{}".format(iio, rio))
        print(template_secsec_functional.format(iio, rio, iio, rio))
        print(template_secsec_auth_init.format(iio, rio, iio, rio))
        print(template_secsec_auth_resp.format(iio, rio, iio, rio))
        print(template_secsec_weaksecret_init.format(iio, rio, iio, rio))
        print(template_secsec_weaksecret_resp.format(iio, rio, iio, rio))
        print(template_secsec_double_impersonation.format(iio, rio, iio, rio))
        print("#endif")
        print()
        print(ftr1)
        print(ftr)
        print(ftr1)
        print()


        curr_cli = get_cli("s", "s", iio, rio, False, False)
        clis.append(curr_cli)
        all_flags.append(("Sec{}Sec{}".format(iio, rio), curr_cli))

for iio in legi:
    for rio in secr:
        hdr = "/* Lemmas about Leg{}-Sec{} exchange */".format(iio, rio)
        hdr1 = "/*" + "*" * (len(hdr)-4) + "*/"

        ftr = "/* End lemmas about Leg{}-Sec{} exchange */".format(iio, rio)
        ftr1 = "/*" + "*" * (len(ftr)-4) + "*/"
        print(hdr1)
        print(hdr)
        print(hdr1)
        print()
        print("#ifdef Leg{}Sec{}".format(iio, rio))
        print(template_legsec_functional.format(iio, rio, iio, rio))
        print(template_legsec_auth_init.format(iio, rio, iio, rio))
        print(template_legsec_auth_resp.format(iio, rio, iio, rio))
        print(template_legsec_weaksecret_init.format(iio, rio, iio, rio))
        print(template_legsec_weaksecret_resp.format(iio, rio, iio, rio))
        print(template_legsec_double_impersonation.format(iio, rio, iio, rio))
        print("#endif")
        print()
        print(ftr1)
        print(ftr)
        print(ftr1)
        print()

        curr_cli = get_cli("l", "s", iio, rio, False, False)
        clis.append(curr_cli)
        all_flags.append(("Leg{}Sec{}".format(iio, rio), curr_cli))


for iio in seci:
    for rio in legr:
        hdr = "/* Lemmas about Sec{}-Leg{} exchange */".format(iio, rio)
        hdr1 = "/*" + "*" * (len(hdr)-4) + "*/"

        ftr = "/* End lemmas about Sec{}-Leg{} exchange */".format(iio, rio)
        ftr1 = "/*" + "*" * (len(ftr)-4) + "*/"
        print(hdr1)
        print(hdr)
        print(hdr1)
        print()
        print("#ifdef Sec{}Leg{}".format(iio, rio))
        print(template_secleg_functional.format(iio, rio, iio, rio))
        print(template_secleg_auth_init.format(iio, rio, iio, rio))
        print(template_secleg_auth_resp.format(iio, rio, iio, rio))
        print(template_secleg_weaksecret_init.format(iio, rio, iio, rio))
        print(template_secleg_weaksecret_resp.format(iio, rio, iio, rio))
        print(template_secleg_double_impersonation.format(iio, rio, iio, rio))
        print("#endif")
        print()
        print(ftr1)
        print(ftr)
        print(ftr1)
        print()

        curr_cli = get_cli("s", "l", iio, rio, False, False)
        clis.append(curr_cli)
        all_flags.append(("Sec{}Leg{}".format(iio, rio), curr_cli))

def get_all_flags(clis):
    flags = set()
    for ccli in clis:
        elts = ccli.split(" ")
        for elt in elts:
            if elt.startswith("-D"):
                flags.add(elt)
    
    return " ".join(flags)

def extract_flags(cli):
    args = cli.split(" ")
    res = []
    for arg in args:
        if arg.startswith("-D"):
            res.append("\""+arg[2:]+"\"")
    return "[" + ",".join(res) + "]"


print("""/*
* Command-line to generate a Tamarin file with the entire model without all preprocessor macros:
* tamarin-prover ble.spthy {}
*/
""".format(get_all_flags(clis)))
print("/* Command lines to prove individual cases:")
print("\n".join(clis))
print("\n")
print("JSON configuration file:")
print("{")
for name,cli in all_flags:
    cmd = "\"{}\": ".format(name)
    cmd += extract_flags(cli)
    print(cmd + ",")
print("}")
print("*/")
