template_functional = """lemma {}_{}_functional: exists-trace
"
Ex pkP1 pkD1 pkP2 pkD2 dh1 dh2 ck1 ck2 np1 np2 nd1 nd2 sk1 sk2 nk1 nk2 dk1 dk2 ak1 ak2 #i #j.
    DeviceFinishedKeyDistribution(pkD1, pkP1, dh1, ck1, nd1, np1, sk1, nk1, dk1, ak1) @i &
    ProvisionerFinishedProvisioning(pkP2, pkD2, dh2, ck2, np2, nd2, sk2, nk2, dk2, ak2) @j
"
"""

template_auth_prov = """lemma {}_{}_auth_prov:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    ProvisionerFinishedProvisioning(pkP, pkD, dh, ck, np, nd, sk, nk, dk, ak) @i ==>
    (
    Ex #j.
        DeviceFinishedProvisioning(pkD, pkP, dh, ck, nd, np, sk, nk, dk) @j
    )
"
"""

template_auth_dev = """lemma {}_{}_auth_dev:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    DeviceFinishedKeyDistribution(pkD, pkP, dh, ck, nd, np, sk, nk, dk, ak) @i ==>
    (
    Ex #j.
        ProvisionerFinishedProvisioning(pkP, pkD, dh, ck, np, nd, sk, nk, dk, ak) @j
    )
"
"""

template_weaksecret_nk_prov = """lemma {}_{}_weaksecret_nk_prov:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    ProvisionerFinishedProvisioning(pkP, pkD, dh, ck, np, nd, sk, nk, dk, ak) @i ==>
    not (Ex #j. K(nk) @j)
"
"""

template_weaksecret_dk_prov = """lemma {}_{}_weaksecret_dk_prov:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    ProvisionerFinishedProvisioning(pkP, pkD, dh, ck, np, nd, sk, nk, dk, ak) @i ==>
    not (Ex #j. K(dk) @j)
"
"""

template_weaksecret_ak_prov = """lemma {}_{}_weaksecret_ak_prov:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    ProvisionerFinishedProvisioning(pkP, pkD, dh, ck, np, nd, sk, nk, dk, ak) @i ==>
    not (Ex #j. K(ak) @j)
"
"""

template_weaksecret_nk_dev = """lemma {}_{}_weaksecret_nk_dev:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    DeviceFinishedKeyDistribution(pkD, pkP, dh, ck, nd, np, sk, nk, dk, ak) @i ==>
    not (Ex #j. K(nk) @j)
"
"""

template_weaksecret_dk_dev = """lemma {}_{}_weaksecret_dk_dev:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    DeviceFinishedKeyDistribution(pkD, pkP, dh, ck, nd, np, sk, nk, dk, ak) @i ==>
    not (Ex #j. K(dk) @j)
"
"""

template_weaksecret_ak_dev = """lemma {}_{}_weaksecret_ak_dev:
"
All pkP pkD dh ck np nd sk nk dk ak #i.
    DeviceFinishedKeyDistribution(pkD, pkP, dh, ck, nd, np, sk, nk, dk, ak) @i ==>
    not (Ex #j. K(ak) @j)
"
"""

template_double_impersonation = """lemma {}_{}_double_impersonation:
"
All pkP1 pkD1 pkP2 pkD2 dh1 dh2 ck1 ck2 np1 np2 nd1 nd2 sk1 sk2 nk1 nk2 dk1 dk2 ak1 ak2 #i #j.
    DeviceFinishedKeyDistribution(pkD1, pkP1, dh1, ck1, nd1, np1, sk1, nk1, dk1, ak1) @i &
    ProvisionerFinishedProvisioning(pkP2, pkD2, dh2, ck2, np2, nd2, sk2, nk2, dk2, ak2) @j ==>
    not (Ex #k1 #k2 #k3 #k4 .
        K(nk1) @k1 & K(dk1) @k2 & K(nk2) @k3 & K(dk2) @k4
    )
"
"""

def get_cli(pe, de, pa, da, prov_unpatched, dev_unpatched):
    cli = ["tamarin-prover", "mesh.spthy"]
    # Legacy or Secure Pairing
    cli.append(f"-DProv{pe}")
    cli.append(f"-DProv{pe}{pa}")
    cli.append(f"-DProv{pa}")

    cli.append(f"-DDev{de}")
    cli.append(f"-DDev{de}{da}")
    cli.append(f"-DDev{da}")

    cli.append("-DProvECDH")
    cli.append("-DDevECDH")

    if prov_unpatched:
        cli.append("-DProvECDHUnpatched")

    if dev_unpatched:
        cli.append("-DDevECDHUnpatched")

    cli.append(f"-D{pe}{pa}{de}{da}")

    cli.append("--prove")
    return " ".join(cli)

exchanges = ["Ei", "Eo"]
auths = ["OOBno", "OOBi", "OOBo", "OOBs"]

all_flags = []

clis = []
for pe in exchanges:
    for de in exchanges:
        for pa in auths:
            for da in auths:
                hdr = "/* Lemmas about {}{}-{}{} exchange */".format(pe,pa,de,da)
                hdr1 = "/*" + "*" * (len(hdr)-4) + "*/"

                ftr = "/* End lemmas about {}{}-{}{} exchange */".format(pe,pa,de,da)
                ftr1 = "/*" + "*" * (len(ftr)-4) + "*/"
                print(hdr1)
                print(hdr)
                print(hdr1)
                print()
                print("#ifdef {}{}{}{}".format(pe,pa,de,da))
                print(template_functional.format(pe+pa, de+da))
                print(template_auth_prov.format(pe+pa, de+da))
                print(template_auth_dev.format(pe+pa, de+da))
                print(template_weaksecret_nk_prov.format(pe+pa, de+da))
                print(template_weaksecret_dk_prov.format(pe+pa, de+da))
                print(template_weaksecret_ak_prov.format(pe+pa, de+da))
                print(template_weaksecret_nk_dev.format(pe+pa, de+da))
                print(template_weaksecret_dk_dev.format(pe+pa, de+da))
                print(template_weaksecret_ak_dev.format(pe+pa, de+da))
                print(template_double_impersonation.format(pe+pa, de+da))
                print("#endif")
                print()
                print(ftr1)
                print(ftr)
                print(ftr1)
                print()

                curr_cli = get_cli(pe, de, pa, da, False, False)
                clis.append(curr_cli)
                all_flags.append(("{}{}{}{}".format(pe,pa,de,da), curr_cli))

def get_all_flags(clis):
    flags = set()
    for ccli in clis:
        elts = ccli.split(" ")
        for elt in elts:
            if elt.startswith("-D"):
                flags.add(elt)
    
    return " ".join(flags)

def extract_flags(cli):
    args = cli.split(" ")
    res = []
    for arg in args:
        if arg.startswith("-D"):
            res.append("\""+arg[2:]+"\"")
    return "[" + ",".join(res) + "]"


print("""/*
* Command-line to generate a Tamarin file with the entire model without all preprocessor macros:
* tamarin-prover mesh.spthy {}
*/
""".format(get_all_flags(clis)))
print("/* Command lines to prove individual cases:")
print("\n".join(clis))
print("\n")
print("JSON configuration file:")
print("{")
for name,cli in all_flags:
    cmd = "\"{}\": ".format(name)
    cmd += extract_flags(cli)
    print(cmd + ",")
print("}")
print("*/")
